Attribute VB_Name = "ZipUnzip"
Public Type ZIPnames
    s(0 To 99) As String
End Type

Private Type ZPOPT
  fSuffix As Long
  fEncrypt As Long
  fSystem As Long
  fVolume As Long
  fExtra As Long
  fNoDirEntries As Long
  fExcludeDate As Long
  fIncludeDate As Long
  fVerbose As Long
  fQuiet As Long
  fCRLF_LF As Long
  fLF_CRLF As Long
  fJunkDir As Long
  fRecurse As Long
  fGrow As Long
  fForce As Long
  fMove As Long
  fDeleteEntries As Long
  fUpdate As Long
  fFreshen As Long
  fJunkSFX As Long
  fLatestTime As Long
  fComment As Long
  fOffsets As Long
  fPrivilege As Long
  fEncryption As Long
  fRepair As Long
  flevel As Byte
  date As String
  szRootDir As String
End Type

Private Type ZIPUSERFUNCTIONS
  DllPrnt As Long
  DLLPASSWORD As Long
  DLLCOMMENT As Long
  DLLSERVICE As Long
End Type


Dim MYOPT As ZPOPT
Dim MYUSER As ZIPUSERFUNCTIONS

Private Type U_CBChar
  ch(32800) As Byte
End Type

Private Type Z_CBChar
  ch(4096) As Byte
End Type


Private Type CBCh
  ch(256) As Byte
End Type


Private Type DCLIST
  ExtractOnlyNewer As Long
  SpaceToUnderscore As Long
  PromptToOverwrite As Long
  fQuiet As Long
  ncflag As Long
  ntflag As Long
  nvflag As Long
  nUflag As Long
  nzflag As Long
  ndflag As Long
  noflag As Long
  naflag As Long
  nZIflag As Long
  C_flag As Long
  fPrivilege As Long
  Zip As String
  ExtractDir As String
End Type


Private Type USERFUNCTION
  DllPrnt As Long
  DLLSND As Long
  DLLREPLACE As Long
  DLLPASSWORD As Long
  DLLMESSAGE As Long
  DLLSERVICE As Long
  TotalSizeComp As Long
  TotalSize As Long
  CompFactor As Long
  NumMembers As Long
  cchComment As Integer
End Type


Private Type UZPVER
  structlen As Long
  flag As Long
  beta As String * 10
  date As String * 20
  zlib As String * 10
  Unzip(1 To 4) As Byte
  zipinfo(1 To 4) As Byte
  os2dll As Long
  windll(1 To 4) As Byte
End Type

Private Declare Function windll_unzip Lib "unzip32.dll" _
    (ByVal ifnc As Long, ByRef ifnv As ZIPnames, _
     ByVal xfnc As Long, ByRef xfnv As ZIPnames, _
     dcll As DCLIST, Userf As USERFUNCTION) As Long

Private Declare Sub UzpVersion2 Lib "unzip32.dll" _
    (uzpv As UZPVER)


Dim MYDCL As DCLIST
Dim U_MYUSER As USERFUNCTION
Dim MYVER As UZPVER

Public vbzipnum As Long, vbzipmes As String
Public vbzipnam As ZIPnames
Public vbxnames As ZIPnames


Function FnPtr(ByVal lp As Long) As Long
  FnPtr = lp
End Function


Function DllPrnt(ByRef fname As Z_CBChar, ByVal AnzChars As Long) As Long
  Dim t&, a$

  On Error Resume Next
  
  For t = 0 To AnzChars
    If fname.ch(t) <> 10 Then
      a = a + Chr(fname.ch(t))
    End If
  Next t
  DllPrnt = 0
End Function


Function DllPass(ByRef s1 As Byte, X As Long, _
  ByRef s2 As Byte, ByRef s3 As Byte) As Long

  On Error Resume Next
  
  
  DllPass = 1
End Function

Function DllRep(ByRef fname As U_CBChar) As Long
  Dim s0$, xx As Long

  On Error Resume Next
  
  DllRep = 100
  s0 = ""
  For xx = 0 To 255
    If fname.ch(xx) = 0 Then xx = 99999 Else s0 = s0 + Chr(fname.ch(xx))
  Next xx
  xx = MsgBox("Datei '" + s0 + "' overwrite?", vbYesNoCancel Or vbQuestion, "Confirm")
  If xx = vbNo Then Exit Function
  If xx = vbCancel Then
    DllRep = 104
    Exit Function
  End If
  
  DllRep = 102
End Function

Sub ReceiveDllMessage(ByVal ucsize As Long, ByVal csiz As Long, _
                    ByVal cfactor As Integer, ByVal mo As Integer, ByVal dy As Integer, _
                    ByVal yr As Integer, ByVal hh As Integer, ByVal mm As Integer, _
                    ByVal c As Byte, ByRef fname As CBCh, ByRef meth As CBCh, ByVal crc As Long, _
                    ByVal fCrypt As Byte)
    
    Dim s0$, xx As Long
    Dim strout As String * 80
  
    On Error Resume Next
    strout = Space(80)
    If vbzipnum = 0 Then
        Mid$(strout, 1, 50) = "Filename:"
        Mid$(strout, 53, 4) = "Size"
        Mid$(strout, 62, 4) = "Date"
        Mid$(strout, 71, 4) = "Time"
        vbzipmes = strout + vbCrLf
        strout = Space(80)
    End If
    s0 = ""
    For xx = 0 To 255
        If fname.ch(xx) = 0 Then xx = 99999 Else s0 = s0 & Chr$(fname.ch(xx))
    Next xx
    Mid$(strout, 1, 50) = Mid$(s0, 1, 50)
    Mid$(strout, 51, 7) = Right$("        " + Str$(ucsize), 7)
    Mid$(strout, 60, 3) = Right$(Str$(dy), 2) + "/"
    Mid$(strout, 63, 3) = Right$("0" + Trim$(Str$(mo)), 2) + "/"
    Mid$(strout, 66, 2) = Right$("0" + Trim$(Str$(yr)), 2)
    Mid$(strout, 70, 3) = Right$(Str$(hh), 2) + ":"
    Mid$(strout, 73, 2) = Right$("0" + Trim$(Str$(mm)), 2)
  
    vbzipmes = vbzipmes + strout + vbCrLf
    vbzipnum = vbzipnum + 1
  
    Dim mName As String
    mName = Mid$(s0, 1, 50)
    
    If Right(mName, 3) = "bsp" Then
        frmMain.pakMaps.AddItem Right(mName, Len(mName) - InStrRev(mName, "/", -1, vbTextCompare))
    End If
End Sub


Public Sub ListAllMaps()
    frmMain.pakMaps.Clear
    Dim AnzDateien%, Archiv$, t%, r&
    Dim na&, nb&
    Dim N, I As Integer
    Dim tPath As String
    frmMain.pakList.Path = Q3Path + "\baseq3"
    For N = 0 To frmMain.pakList.ListCount - 1
        If frmMain.pakList.List(N) <> "pak0.pk3" Then
            frmMapSearch.lblStatus.Caption = "baseq3\" + frmMain.pakList.List(N)
            frmMapSearch.Refresh
            VBUnzip Q3Path + "\baseq3\" + frmMain.pakList.List(N), "", 0, 1, 1, 0, na, nb
        End If
    Next N
    frmMapSearch.lblHeader.Caption = "Getting Map Names..."
    frmMapSearch.Refresh
    WaitASecond
  
End Sub



Function szTrim(szString As String) As String
  Dim pos As Integer, ln As Integer
  
  pos = InStr(szString, Chr$(0))
  ln = Len(szString)
  Select Case pos
    Case Is > 1
      szTrim = Trim(Left(szString, pos - 1))
    Case 1
      szTrim = ""
    Case Else
      szTrim = Trim(szString)
  End Select
  
End Function


Sub VBUnzip(fname As String, extdir As String, _
  prom As Integer, ovr As Integer, _
  mess As Integer, dirs As Integer, numfiles As Long, numxfiles As Long)
  
  Dim xx As Long
  
  MYDCL.ExtractOnlyNewer = 0      ' 1=extract only newer
  MYDCL.SpaceToUnderscore = 0     ' 1=convert space to underscore
  MYDCL.PromptToOverwrite = prom  ' 1=prompt to overwrite required
  MYDCL.fQuiet = 0                ' 2=no messages 1=less 0=all
  MYDCL.ncflag = 0                ' 1=write to stdout
  MYDCL.ntflag = 0                ' 1=test zip
  MYDCL.nvflag = mess             ' 0=extract 1=list contents
  MYDCL.nUflag = 0                ' 1=extract only newer
  MYDCL.nzflag = 0                ' 1=display zip file comment
  MYDCL.ndflag = dirs             ' 1=honour directories
  MYDCL.noflag = ovr              ' 1=overwrite files
  MYDCL.naflag = 0                ' 1=convert CR to CRLF
  MYDCL.nZIflag = 0               ' 1=Zip Info Verbose
  MYDCL.C_flag = 0                ' 1=Case insensitivity, 0=Case Sensitivity
  MYDCL.fPrivilege = 0            ' 1=ACL 2=priv
  MYDCL.Zip = fname               ' ZIP name
  MYDCL.ExtractDir = extdir       ' Extraction directory, NULL if extracting to current directory

  U_MYUSER.DllPrnt = FnPtr(AddressOf DllPrnt)
  U_MYUSER.DLLSND = 0& ' not supported
  U_MYUSER.DLLREPLACE = FnPtr(AddressOf DllRep)
  U_MYUSER.DLLPASSWORD = FnPtr(AddressOf DllPass)
  U_MYUSER.DLLMESSAGE = FnPtr(AddressOf ReceiveDllMessage)
  U_MYUSER.DLLSERVICE = 0& ' not coded yet :)
  
  With MYVER
    .structlen = Len(MYVER)
    .beta = Space$(9) & vbNullChar
    .date = Space$(19) & vbNullChar
    .zlib = Space$(9) & vbNullChar
  End With
 
  Call UzpVersion2(MYVER)
 
  xx = windll_unzip(numfiles, vbzipnam, numxfiles, vbxnames, MYDCL, U_MYUSER)
  
  If xx <> 0 Then
    MsgBox "Error: " & fname, vbCritical, "Error"
  End If

End Sub


Function DllComm(ByRef s1 As Z_CBChar) As Z_CBChar
  On Error Resume Next
  s1.ch(0) = vbNullString
  DllComm = s1
End Function




