VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmPath 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Servarena - Developed by Snow Dog"
   ClientHeight    =   2310
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6270
   Icon            =   "frmSelectExe.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2310
   ScaleWidth      =   6270
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Visible         =   0   'False
   Begin VB.PictureBox Picture1 
      Height          =   2055
      Left            =   120
      Picture         =   "frmSelectExe.frx":08CA
      ScaleHeight     =   1995
      ScaleWidth      =   1575
      TabIndex        =   6
      Top             =   120
      Width           =   1635
      Begin VB.Line Line1 
         BorderColor     =   &H000000FF&
         BorderWidth     =   2
         X1              =   1080
         X2              =   1440
         Y1              =   1800
         Y2              =   1800
      End
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   435
      Left            =   4800
      TabIndex        =   2
      Top             =   1740
      Width           =   1155
   End
   Begin VB.CommandButton cmdOkay 
      Caption         =   "&Okay"
      Enabled         =   0   'False
      Height          =   435
      Left            =   3540
      TabIndex        =   1
      Top             =   1740
      Width           =   1155
   End
   Begin VB.Frame Frame1 
      Caption         =   "Quake 3 Arena Executable"
      Height          =   1575
      Left            =   1920
      TabIndex        =   4
      Top             =   60
      Width           =   4215
      Begin VB.CommandButton cmdBrowse 
         Height          =   615
         Left            =   3300
         Picture         =   "frmSelectExe.frx":B08C
         Style           =   1  'Graphical
         TabIndex        =   0
         Top             =   780
         Width           =   735
      End
      Begin VB.TextBox txtPath 
         Height          =   315
         Left            =   180
         TabIndex        =   3
         TabStop         =   0   'False
         Top             =   360
         Width           =   3855
      End
      Begin VB.Label Label1 
         Caption         =   "Select the full path to the Quake 3 Arena executable (quake3.exe)."
         Height          =   435
         Left            =   180
         TabIndex        =   5
         Top             =   840
         Width           =   3015
      End
   End
   Begin MSComDlg.CommonDialog cDialog 
      Left            =   300
      Top             =   3000
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Select the Quake 3 Executable"
      Filter          =   "Executables (*.exe)|*.exe"
   End
End
Attribute VB_Name = "frmPath"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim GotPath As Boolean

Private Sub cmdBrowse_Click()
    
    Dim TmpPath As String
    Dim TmpTitle As Integer
    Dim TmpExe As String
    
    On Error GoTo nofile
    cDialog.ShowOpen
    TmpPath = cDialog.filename
    TmpExe = cDialog.FileTitle
    TmpTitle = Len(TmpExe)
    
    txtPath.Text = TmpPath
    Q3Path = Left(TmpPath, Len(TmpPath) - (TmpTitle + 1))
    Q3Exe = TmpExe
        
    GotPath = True
    cmdOkay.SetFocus
    
Done:
    Exit Sub
       
nofile:
    Resume Done
End Sub

Private Sub cmdCancel_Click()
    If chQ3Path = True Then
        Unload Me
        Exit Sub
    End If
    GotPath = False
    End
End Sub

Private Sub cmdOkay_Click()

    SaveSetting App.EXEName, "Settings", "Path", Q3Path
    SaveSetting App.EXEName, "Settings", "Exe", Q3Exe
    
'    frmMain.txtPath.Text = Q3Path + "\" + Q3Exe
    
    GotPath = True
    Unload Me
        
End Sub

Private Sub Form_Load()

    Me.Hide

    Q3Path = GetSetting(App.EXEName, "Settings", "Path", "")
    Q3Exe = GetSetting(App.EXEName, "Settings", "Exe", "")
    
    If Q3Path > "" Then
        If Exists(Q3Path + "\quake3.exe") = False Then
            Q3Path = ""
            Q3Exe = ""
            gotConfig = False
        End If
    End If
    
    If gotConfig = False Then
    
        If Q3Path = "" Or Q3Exe = "" Then
    
            NoConfig = True
            GotPath = False
            Me.Show
            Me.Visible = True
    
        Else
    
            GotPath = True
            Unload Me
    
        End If
    
    Else
        txtPath.Text = Q3Path + "\" + Q3Exe
        Me.Show
        Me.Visible = True
   
        
    End If
    

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    If GotPath = False Then
        If Loading = True Then
            End
        Else
            frmMain.Enabled = True
            frmMain.Show
            frmMain.SSTab1.Tab = 0
            frmMain.txtMOTD.SetFocus
        End If
    Else
        If chPath = False Then
            frmMain.Show
            frmMain.Enabled = True
            frmMain.SSTab1.Tab = 0
            frmMain.txtMOTD.SetFocus
        End If
    End If
End Sub

Private Sub txtPath_Change()
    If txtPath.Text > "" Then
        cmdOkay.Enabled = True
    Else
        cmdOkay.Enabled = False
    End If
End Sub
