VERSION 5.00
Begin VB.Form frmMap 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Add a Map"
   ClientHeight    =   3615
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6075
   Icon            =   "frmMap.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3615
   ScaleWidth      =   6075
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00000000&
      Height          =   3255
      Left            =   180
      ScaleHeight     =   3195
      ScaleWidth      =   2295
      TabIndex        =   7
      Top             =   180
      Width           =   2355
      Begin VB.Label Label6 
         BackStyle       =   0  'Transparent
         Caption         =   $"frmMap.frx":08CA
         ForeColor       =   &H0000C0C0&
         Height          =   1575
         Left            =   60
         TabIndex        =   11
         Top             =   1560
         Width           =   2175
      End
      Begin VB.Label Label5 
         BackStyle       =   0  'Transparent
         Caption         =   $"frmMap.frx":099C
         ForeColor       =   &H0000C0C0&
         Height          =   1515
         Left            =   60
         TabIndex        =   8
         Top             =   60
         Width           =   2115
      End
   End
   Begin VB.Frame Frame1 
      Height          =   2715
      Left            =   2700
      TabIndex        =   4
      Top             =   90
      Width           =   3195
      Begin VB.TextBox txtMapName 
         Height          =   315
         Left            =   240
         MaxLength       =   30
         TabIndex        =   1
         Top             =   1740
         Width           =   2715
      End
      Begin VB.TextBox txtFileName 
         Height          =   315
         Left            =   240
         MaxLength       =   20
         TabIndex        =   0
         Top             =   540
         Width           =   2715
      End
      Begin VB.Label Label1 
         Caption         =   "Map Name"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   1500
         Width           =   2715
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         Caption         =   "This is the name of the map, for example ""The Longest Yard"""
         Height          =   495
         Left            =   240
         TabIndex        =   9
         Top             =   2100
         Width           =   2715
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         Caption         =   "This is the file name, without the .bsp extension.  For example:  q3tourney1"
         Height          =   555
         Left            =   240
         TabIndex        =   6
         Top             =   900
         Width           =   2715
      End
      Begin VB.Label Label2 
         Caption         =   "File Name"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   240
         TabIndex        =   5
         Top             =   300
         Width           =   2715
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Okay"
      Default         =   -1  'True
      Height          =   435
      Left            =   4380
      TabIndex        =   3
      Top             =   3000
      Width           =   1515
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   435
      Left            =   2700
      TabIndex        =   2
      Top             =   3000
      Width           =   1515
   End
   Begin VB.Label lblIndexNum 
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   3840
      Visible         =   0   'False
      Width           =   2355
   End
End
Attribute VB_Name = "frmMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Command1_Click()
    Unload Me
End Sub

Function CheckValidMap() As Boolean
    CheckValidMap = False
    
    
    If txtFileName.Text = "" Then
        MsgBox "You must specify at least a file name for the new map.", vbInformation, "Incomplete Information"
        txtFileName.SetFocus
        Exit Function
    End If
    
    If txtMapName.Text = "" Then
        txtMapName.Text = txtFileName.Text
    End If
    
    Dim dPos As Integer
    dPos = InStr(1, txtFileName.Text, ".", vbTextCompare)
    If dPos > 0 Then
        MsgBox "The file name should not include a file extension!", vbInformation, "Warning"
        txtFileName.SelStart = dPos - 1
        txtFileName.SelLength = Len(txtFileName.Text) - (dPos - 1) 'Len(txtFileName.Text)
        txtFileName.SetFocus
        Exit Function
    End If
    
    If InStr(1, txtFileName.Text, " ", vbTextCompare) > 0 Then
        MsgBox "Spaces are not allowed in map file names!", vbInformation, "Warning"
        txtFileName.SelStart = 0
        txtFileName.SelLength = Len(txtFileName.Text)
        txtFileName.SetFocus
        Exit Function
    End If
    
    CheckValidMap = True

End Function

Private Sub Command2_Click()
    If CheckValidMap = False Then Exit Sub

    Dim NewIndex As Integer

    If Me.Caption = "Add a Map" Then
        AddNewMap
    Else
        UpdateMap
    End If
    
End Sub


Sub AddNewMap()

    If FindMap(txtFileName.Text) > -1 Then
        MsgBox "That map already exists!", vbInformation, "Get some rest!"
        Exit Sub
    End If
    
    If frmMain.MapList.ListCount > 0 Then
        NewIndex = TotalMaps + 1
    Else
        NewIndex = 1
    End If
    
'    LastMap = -1
    
    With Map
        .Name = Trim(txtMapName.Text)
        .FileName = Trim(txtFileName.Text)
        .TimeLimit = dfTimeLimit
        .CaptureLimit = dfCaptureLimit
        .FragLimit = dfFragLimit
        .Gravity = dfGravity
        .Speed = dfSpeed
        .KnockBack = dfKnockBack
    End With
        
    Open App.Path + "\maps.dat" For Random As #8 Len = Len(Map)
        Put #8, NewIndex, Map
    Close #8
    
    frmMain.MapList.AddItem Trim(txtFileName.Text)
    frmMain.MapList.ListIndex = frmMain.MapList.ListCount - 1
    frmMain.MapList.SetFocus
    Unload Me

End Sub

Sub UpdateMap()
    
    frmMain.lblMap.Text = Trim(txtMapName.Text)
    frmMain.lblMapFilename.Caption = Trim(txtFileName.Text)
    NewIndex = EditMapNum
    
    With Map
        .Name = Trim(txtMapName.Text)
        .FileName = Trim(txtFileName.Text)
    End With
        
    Open App.Path + "\maps.dat" For Random As #8 Len = Len(Map)
        Put #8, NewIndex, Map
    Close #8
   
    Dim mIdx As Integer
    mIdx = Val(lblIndexNum.Caption)
    frmMain.MapList.RemoveItem mIdx
    frmMain.MapList.AddItem Trim(txtFileName.Text), mIdx
    frmMain.MapList.SetFocus
    Unload Me

End Sub
